version: '3.7'

services:
  web:
    build:
      context: .
      dockerfile: Dockerfile.prod
    command: /bin/sh -c 'pip install -e . && gunicorn tanbot.wsgi:application --bind 0.0.0.0:8000 --timeout 600'
    volumes:
      - static_volume:/home/app/web/static
    ports:
      - 8000:8000
    env_file:
      - .env.staging
    links:
      - redis
    depends_on:
      - celery
      - celery-beat
      - db
  db:
    image: postgres
    volumes:
      - postgres_data:/var/lib/postgresql/data/
    environment:
      - POSTGRES_USER=postgres
      - POSTGRES_PASSWORD=postgres
      - POSTGRES_DB=postgres

  nginx-proxy:
    container_name: nginx-proxy
    build: nginx
    restart: always
    ports:
      - 443:443
      - 80:80
    volumes:
      - static_volume:/home/app/web/static
      - certs:/etc/nginx/certs
      - html:/usr/share/nginx/html
      - vhost:/etc/nginx/vhost.d
      - /var/run/docker.sock:/tmp/docker.sock:ro
    depends_on:
      - web
  nginx-proxy-letsencrypt:
    image: jrcs/letsencrypt-nginx-proxy-companion
    env_file:
      - .env.staging.proxy-companion
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock:ro
      - certs:/etc/nginx/certs
      - html:/usr/share/nginx/html
      - vhost:/etc/nginx/vhost.d
    depends_on:
      - nginx-proxy

  redis:
    image: redis:alpine
  celery:
    build:
      context: .
    command: bash -c "pip install -e . && celery -A tanbot worker -l info"
    # volumes:
    #   - .:/home/app/web/
    env_file:
      - .env.staging
    links:
      - redis
  celery-beat:
    build:
      context: .
    command: bash -c "pip install -e . && celery -A tanbot beat -l info"
    # volumes:
    #   - ../db:/home/app/web/
    env_file:
      - .env.staging
    links:
      - redis

volumes:
  static_volume:
  certs:
  html:
  vhost:
  postgres_data:
